/************************************************************************/
/*	BLASOptions.h: definitions for C BLAS options characters	*/
/*									*/
/************************************************************************/
/* SCCS INFO @(#)BLASOptions.h 1.1         last modified P. Strazdins, 98/12/24
   first created: P. Strazdins 91/12
 */
      
#ifndef __BLASOptions_INCL__

#define __BLASOptions_INCL__
  
#define Left 		'L'
#define Right 		'R'
#define Upper 		'U'
#define Lower 		'L'
#define Rectangular 	'R'
#define Unit 		'U'
#define NonUnit 	'N'
#define NoTranspose 	'N'
#define Transpose 	'T'
#define ConjTranspose 	'C'
#define Forward		'F'
#define Backward	'B'
#define	Row		'R'
#define	Col		'C'

#define SideOK(S) 	(((S)==Left)  | ((S)==Right))
#define UpLoOK(U) 	(((U)==Upper) | ((U)==Lower))
#define DiagOK(D) 	(((D)==Unit)  | ((D)==NonUnit))
#define TransOK(T) 	(((T)==Transpose) | ((T)==NoTranspose))

#define DirectOK(D) 	(((D)==Forward)  | ((D)==Backward))
#define StoreOK(S) 	(((S)==Row)  | ((S)==Col))

#define TransForm(c)	((c)==Upper? Lower: (c)==Lower? Upper: (c))  

#endif /*__BLASOptions_INCL__*/
