/************************************************************************/
/*         D_CellHolds: Level 1 Distributed BLAS holds submatrix predicate*/
/************************************************************************/
/* SCCS INFO @(#)D_CellHolds.c 1.1         last modified P. Strazdins, 98/12/24
   first created: P. Strazdins 96/01
 */
/* see D_GEMM.c for common cpp flag description                         */

#include "D_BLAS.h"
#include "D_BLASCheck.h"

#include "BLASOptions.h"
#include "FDATASetUp.h"
#include "FDAssert.h"
#include "FDMalloc.h"

#include "LocMat.h"
#include "MatDim.h"
#include "DistMat.h"

#include "CellMatrix.h"		/* MatScale(), MatCopy/Add(), MatMult() */
#include "FDCommun.h"

int D_CellHolds (M, N, A) 
  int M; int N; DistMat A; 
{ int ParamErr=0;

  if (!NoOuterErrCheck) {
    CheckParam(ParamErr, DimOK(M), 1.0);
    CheckParam(ParamErr, DimOK(N), 2.0);
    CheckParam(ParamErr, DM_OK(A), 0x3);
  }

  ERROR_CHECK_TR(
    (TraceStr, "(%dx%d,%s)", M, N, DM_TRACE(0, A)),
    ParamErr, "CellHolds", 2
  );
    
  TRACE_RETURN ((d_P0(DM_DM(A)) < NBLKSd(M, DM_DM(A))) && 
  	        (d_P0(DM_DN(A)) < NBLKSd(N, DM_DN(A))));
} /* D_CellHolds() */

