/************************************************************************/
/*         D_GER: Level 2 Distributed BLAS rank-1 update		*/
/************************************************************************/
/* SCCS INFO @(#)D_GER.c 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 95/03
 */
/* see D_GEMM.c for common cpp flag description                         */

#include "D_BLAS.h"
#include "D_BLASCheck.h"

#include "BLASOptions.h"
#include "FDATASetUp.h"
#include "FDAssert.h"

#include "LocMat.h"
#include "MatDim.h"
#include "DistMat.h"
#include "FDCommun.h"  			/* CommSetUp() */

#include "GenMult.h"

void D_GER (M, N,  alpha, X, Y, A)
  int M; int N;  FDATA alpha; DistMat X; DistMat Y; DistMat A;
{ int ParamErr=0;
  int AlignM, AlignN;
  AlphaDecln();

  if (!NoOuterErrCheck) {
    CheckAlign(ParamErr, AlignM, M, DM_Inc(1-Tr(X), X),   DM_DM(X),
               DM_Inc(1-Tr(A), A),   DM_DM(A), 0x146);
    CheckParam(ParamErr, AlignM && d_P(DM_DM(X))==DM_P(Tr(X), A) &&
                         P_OK(d_P(DM_DN(X)), DM_P(1-Tr(X), A)), 0x46);
    CheckAlign(ParamErr, AlignN, N, DM_Inc(1-Tr(Y), Y), DM_DM(Y),
               DM_Inc(Tr(A), A), DM_DN(A), 0x256);
    CheckParam(ParamErr, AlignN && d_P(DM_DM(Y))==DM_P(Tr(Y), A) &&
                         P_OK(d_P(DM_DN(Y)), DM_P(1-Tr(Y), A)), 0x56);
  }

  SetUpComm(A);
  ERROR_CHECK_TR(   
    (TraceStr, "(%d,%d,%s,%s,%s,%s)", M, N, pFD2Str(&alpha), 
    DM_TRACE(0, X), DM_TRACE(1, Y), DM_TRACE(2, A)),
    ParamErr,  "GER", 1
  );

  AlphaSet(alpha, pAlpha); 
  DistRankKMult(M, N, 1, pAlpha, X, Trans(Y), NULL, A);
  TRACE_EXIT;
} /* D_GER() */

