/************************************************************************/
/*         D_GetElt: Level 1 Distributed BLAS get matrix element	*/
/************************************************************************/
/* SCCS INFO @(#)D_GetElt.c 1.1         last modified P. Strazdins, 98/12/24
   first created: P. Strazdins 96/01
 */

/* see D_GEMM.c for common cpp flag description                         */

#include "D_BLAS.h"
#include "D_BLASCheck.h"

#include "BLASOptions.h"
#include "FDATASetUp.h"
#include "FDAssert.h"
#include "FDMalloc.h"

#include "LocMat.h"
#include "MatDim.h"
#include "DistMat.h"

#include "CellMatrix.h"		/* MatScale(), MatCopy/Add(), MatMult() */
#include "FDCommun.h"

FDATA D_GetElt (A) 
  DistMat A;
{ FDATA v;
  int ParamErr=0;

  if (!NoOuterErrCheck) 
    CheckParam(ParamErr, DM_OK(A), 0x1);
 
  SetUpComm(A);
  ERROR_CHECK_TR( (TraceStr, "(%s)", DM_TRACE(0, A)), ParamErr, "GetElt", 2);

  if (!d_P0(DM_D0(A)) && !d_P0(DM_D1(A))) 
    v = *LM_ADR(DM_Loc(A));
  if (d_P(DM_D0(A))>1)  
    BrdMat(0, d_P0(DM_D0(A)), 1, 1, &v, 1);
  if (d_P(DM_D1(A))>1)  
    BrdMat(1, d_P0(DM_D1(A)), 1, 1, &v, 1);
  TRACE_RETURN(v);  
} /* D_GetElt() */
