/************************************************************************/
/*         D_SYR: Level 2 Distributed BLAS symmetric rank-1 update	*/
/************************************************************************/
/* SCCS INFO @(#)D_SYR.c 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 95/03
 */
/* see D_GEMM.c for common cpp flag description                         */

#include "D_BLAS.h"
#include "D_BLASCheck.h"

#include "BLASOptions.h"
#include "FDATASetUp.h"
#include "FDAssert.h"

#include "LocMat.h"
#include "MatDim.h"
#include "DistMat.h"
#include "FDCommun.h"  			/* CommSetUp() */

#include "SYRKMult.h"

void D_SYR (UpLo, N, alpha, X, A)
  char *UpLo; int N; FDATA alpha; DistMat X; DistMat A;
{ int ParamErr=0;			int AlignN;
  char UpLoA = UpperCase(*UpLo); 
  AlphaDecln();

  if (!NoOuterErrCheck) {
    CheckParam(ParamErr, UpLoOK(UpLoA), 0x1);  
    CheckAlign(ParamErr, AlignN, N, DM_Inc(1-Tr(X), X),   DM_DM(X),
               DM_Inc(1-Tr(A), A),   DM_DM(A), 0x145);
    CheckParam(ParamErr, AlignN && d_P(DM_DM(X))==DM_P(Tr(X), A) &&
                         P_OK(d_P(DM_DN(X)), DM_P(1-Tr(X), A)), 0x45);
    CheckDim(ParamErr, N, DM_Inc(Tr(A), A), DM_DN(A), 0x25);
    CheckParam(ParamErr, Dim_BCompat(DM_D0(A), DM_D1(A)), 0x55);
  }

  SetUpComm(A);
  ERROR_CHECK_TR(
    (TraceStr, "(%c,%d,%s,%s,%s)", 
     *UpLo, N, pFD2Str(&alpha), DM_TRACE(0, X), DM_TRACE(1,A)),
    ParamErr, "SYR", 1
  );

  AlphaSet(alpha, pAlpha);
  DistSYRKMult(N, 1, pAlpha, X, NULL, UpLoA, A);
  TRACE_EXIT;
} /* D_SYR() */

