/************************************************************************/
/*         D_SetElt: Level 1 Distributed BLAS matrix set element	*/
/************************************************************************/
/* SCCS INFO @(#)D_SetElt.c 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 93/03/23
 */

/* see D_GEMM.c for common cpp flag description                         */

#include "D_BLAS.h"
#include "D_BLASCheck.h"

#include "BLASOptions.h"
#include "FDATASetUp.h"
#include "FDAssert.h"
#include "FDMalloc.h"

#include "LocMat.h"
#include "MatDim.h"
#include "DistMat.h"

#include "CellMatrix.h"		/* MatScale(), MatCopy/Add(), MatMult() */
#include "FDCommun.h"

void D_SetElt (A, v)
  DistMat A; FDATA v;
{ int ParamErr=0;

  if (!NoOuterErrCheck)
    CheckParam(ParamErr, DM_OK(A), 0x1);
  
  ERROR_CHECK_TR(
    (TraceStr, "(%s,%s)", DM_TRACE(0,A), pFD2Str(&v)),
    ParamErr, "SetElt", 2
  );

  if (!d_P0(DM_D0(A)) && !d_P0(DM_D1(A))) 
    *LM_ADR(DM_Loc(A)) = v;    
  TRACE_EXIT;
} /* D_SetElt() */

