/************************************************************************/
/*		F2C: definitions for Fortran-C interface		*/
/************************************************************************/
/* SCCS INFO @(#)F2C.h 1.1         last modified P. Strazdins, 98/12/24
   first created: P. Strazdins 96/01/19
*/
/* macros: only one of the following should be defined:
 *	Add_		add `_' to get the Fortran name 	(for Sun, Intel)
 *	NoChange	no chage to get the Fortran name	(for IBM)
 *	UpCase		map to UPPER CASE get the Fortran name 	(for Cray) 
 *			this also implies Cray differnces in char * parameters
 *			and void / integer functions.
 * note: this is based on the UTK PBLAS 2.0 alpha interface definitions
 */	


#ifndef __F2C_INCL__
#define __F2C_INCL__

#if !defined(UpCase) && !defined(NoChange) && !defined(Add_)
# define Add_
#endif

#ifdef UpCase			/* assume Cray T3D or T3E */
# include <fortran.h>

# define float		double
				/* for char * parameters */
# define F_CHAR_T	_fcd
# define F2C_CHAR(a)	( _fcdtocp( (a) ) )
# define C2F_CHAR(a)	( _cptofcd( (a), 1 ) )
				/* for functions */
# define F_VOID_FCT	void fortran
# define F_INTG_FCT	int fortran	

#else 

typedef    char *       F_CHAR_T;
# define F2C_CHAR(a)	(a)
# define C2F_CHAR(a)	(a)
				/* for functions */
# define F_VOID_FCT	void 
# define F_INTG_FCT	int 

#endif

                           
#endif /*__F2C_INCL__*/



