/************************************************************************/
/*                     FDATASetUp		                        */
/************************************************************************/
/* SCCS INFO @(#)FDATASetUp.c 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 91/12
*/
/************************************************************************/

#include "FDATASetUp.h"
#include <stdio.h>				/*sprintf()*/
#include <stdlib.h>				/*afof()*/
#include <string.h>				/*strchr()*/

/* define useful numeric constants; needed as these are passed by address  */
#if (FDATATYPE==SINGLE || FDATATYPE==DOUBLE)
FDATA	
  	FD_1 	= 1.0,
	FD_M1 	= -1.0,
	FD_0 	= 0.0;
#else
FDATA	
	FD_1 	= {1.0, 0.0},
	FD_M1 	= {-1.0, 0.0},
	FD_0 	= {0.0, 0.0},
	FD_I 	= {0.0, 1.0};
#endif

#define NUMFDStr 4
static FDStrCnt = 0;
char FDStr[NUMFDStr+1][32];
 
char *pFD2Str (v)
  FDATA *v;
{ char * str = FDStr[FDStrCnt];
  if (v==NULL)
    strcpy(str,"1");
  else
#if (FDATATYPE==SINGLE || FDATATYPE==DOUBLE)
   sprintf(str, "%1.2e", *v); 
#else      
   sprintf(str, "%1.2e,%1.2e", v->r, v->i);
#endif      
  FDStrCnt = (FDStrCnt+1)%NUMFDStr;
  return(str);
} /* pFD2Str() */

 
FDATA Str2FD (str)
  char *str;
{ FDATA v;
#if (FDATATYPE==SINGLE || FDATATYPE==DOUBLE)
  v = (FD_BASE) atof(str);
#else
  char *im = strchr(str, ',');
  v.r = (FD_BASE) atof(str);
  v.i = im==NULL? 0.0: (FD_BASE) atof(&im[1]);
#endif       
  return(v);
} /* Str2FD() */ 

