/************************************************************************/
/*       	FDAssert: FDATA checking and debugging module     	*/
/************************************************************************/
/* SCCS INFO @(#)FDAssert.h 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 96/01/23
*/
/* assertion checking routines and and tracing parameters used for libraries
 * using FDATA. The macro CELLBLAS can be defined to produce a simple
 * FDATA-dependent prefix.
 */
#ifndef __FDAssert_INCL__
#define __FDAssert_INCL__  

#include "FDATASetUp.h"
#ifdef CALLER_PREFIX
# undef CALLER_PREFIX
#endif 

#ifdef CELLBLAS
# if FDATATYPE==SINGLE
#   define CALLER_PREFIX "S"
# elif FDATATYPE==DOUBLE
#   define CALLER_PREFIX "D"
# elif FDATATYPE==COMPLEX
#   define CALLER_PREFIX "C"
# else
#   define CALLER_PREFIX "Z"
# endif
#else
# if FDATATYPE==SINGLE
#   define CALLER_PREFIX "DS"
# elif FDATATYPE==DOUBLE
#   define CALLER_PREFIX "DD"
# elif FDATATYPE==COMPLEX
#   define CALLER_PREFIX "DC"
# else
#   define CALLER_PREFIX "DZ"
# endif
#endif /*CELLBLAS*/

#include "GenAssert.h"

#endif /*__FDAssert_INCL__*/
