/************************************************************************/
/*		FtnBLACS: C prototypes for Fortran BLACS 		*/ 
/************************************************************************/
/* SCCS INFO @(#)FtnBLACS.h 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 96/01/19
*/
/* compilation:	see F2C.h for macros controlling procedure renaming
 */

#ifndef __FtnBLACS_INCL__
#define __FtnBLACS_INCL__


#include "F2C.h"
#include "FDATASetUp.h"
   
#if FDATATYPE==SINGLE
# define FTN_GESD2D	sgesd2d_
# define FTN_GERV2D	sgerv2d_ 
# define FTN_GEBS2D	sgebs2d_
# define FTN_GEBR2D	sgebr2d_
# define FTN_GSUM2D	sgsum2d_
# define FTN_GAMX2D	sgamx2d_
# define FTN_GAMN2D	sgamn2d_
#elif FDATATYPE==DOUBLE
# define FTN_GESD2D	dgesd2d_
# define FTN_GERV2D	dgerv2d_ 
# define FTN_GEBS2D	dgebs2d_
# define FTN_GEBR2D	dgebr2d_
# define FTN_GSUM2D	dgsum2d_
# define FTN_GAMX2D	dgamx2d_
# define FTN_GAMN2D	dgamn2d_
#elif FDATATYPE==COMPLEX
# define FTN_GESD2D	cgesd2d_
# define FTN_GERV2D	cgerv2d_ 
# define FTN_GEBS2D	cgebs2d_
# define FTN_GEBR2D	cgebr2d_
# define FTN_GSUM2D	cgsum2d_
# define FTN_GAMX2D	cgamx2d_
# define FTN_GAMN2D	cgamn2d_
#else
# define FTN_GESD2D	zgesd2d_
# define FTN_GERV2D	zgerv2d_ 
# define FTN_GEBS2D	zgebs2d_
# define FTN_GEBR2D	zgebr2d_
# define FTN_GSUM2D	zgsum2d_
# define FTN_GAMX2D	zgamx2d_
# define FTN_GAMN2D	zgamn2d_
#endif /*FDATATYPE*/
#define  FTN_BLACS_GRIDINFO	blacs_gridinfo_
#define  FTN_BLACS_BARRIER	blacs_barrier_
#define  FTN_BLACS_ABORT	blacs_abort_
#define  FTN_BLACS_GET		blacs_get_
#define  FTN_BLACS_GRIDINIT	blacs_gridinit_
#define	 FTN_DWALLTIME00	dwalltime00_
#define  FTN_BLACS_PINFO	blacs_pinfo_
#define  FTN_IGEBS2D		igebs2d_
#define  FTN_IGEBR2D		igebr2d_
#define  FTN_BLACS_SETUP	blacs_setup_

#ifdef NoChange
# define sgesd2d_	sgesd2d
# define sgerv2d_	sgerv2d
# define sgebs2d_	sgebs2d
# define sgebr2d_	sgebr2d
# define sgsum2d_	sgsum2d
# define sgamx2d_	sgamx2d
# define sgamn2d_	sgamn2d
# define dgesd2d_	dgesd2d

# define dgerv2d_	dgerv2d
# define dgebs2d_	dgebs2d
# define dgebr2d_	dgebr2d
# define dgsum2d_	dgsum2d
# define dgamx2d_	dgamx2d
# define dgamn2d_	dgamn2d
# define dgesd2d_	dgesd2d

# define zgerv2d_	zgerv2d
# define zgebs2d_	zgebs2d
# define zgebr2d_	zgebr2d
# define zgsum2d_	zgsum2d
# define zgamx2d_	zgamx2d
# define zgamn2d_	zgamn2d

# define dgesd2d_	zgesd2d
# define dgerv2d_	zgerv2d
# define dgebs2d_	zgebs2d
# define dgebr2d_	zgebr2d
# define dgsum2d_	zgsum2d
# define dgamx2d_	zgamx2d
# define dgamn2d_	zgamn2d

# define blacs_gridinfo_ blacs_gridinfo
# define blacs_barrier_ blacs_barrier
# define blacs_abort_	blacs_abort
# define blacs_get_	blacs_get 
# define blacs_gridinit_ blacs_gridinit 
# define blacs_pinfo_	blacs_pinfo
# define blacs_setup_	blacs_setup
# define dwalltime00_	dwalltime00
# define igebs2d_	igebs2d
# define igebr2d_	igebr2d

#endif /*NoChange*/

#ifdef UpCase
# define sgesd2d_	SGESD2D
# define sgerv2d_	SGERV2D
# define sgebs2d_	SGEBS2D
# define sgebr2d_	SGEBR2D
# define sgsum2d_	SGSUM2D
# define sgamx2d_	SGAMX2D
# define sgamn2d_	SGAMN2D

# define dgesd2d_	DGESD2D
# define dgerv2d_	DGERV2D
# define dgebs2d_	DGEBS2D
# define dgebr2d_	DGEBR2D
# define dgsum2d_	DGSUM2D
# define dgamx2d_	DGAMX2D
# define dgamn2d_	DGAMN2D

# define cgesd2d_	CGESD2D
# define cgerv2d_	CGERV2D
# define cgebs2d_	CGEBS2D
# define cgebr2d_	CGEBR2D
# define cgsum2d_	CGSUM2D
# define cgamx2d_	CGAMX2D
# define cgamn2d_	CGAMN2D

# define zgesd2d_	ZGESD2D
# define zgerv2d_	ZGERV2D
# define zgebs2d_	ZGEBS2D
# define zgebr2d_	ZGEBR2D
# define zgsum2d_	ZGSUM2D
# define zgamx2d_	ZGAMX2D
# define zgamn2d_	ZGAMN2D

# define blacs_gridinfo_ BLACS_GRIDINFO
# define blacs_barrier_ BLACS_BARRIER
# define blacs_abort_	BLACS_ABORT
# define blacs_get_	BLACS_GET 
# define blacs_gridinit_ BLACS_GRIDINIT 
# define blacs_pinfo_	BLACS_PINFO
# define blacs_setup_	BLACS_SETUP
# define dwalltime00_	DWALLTIME00
# define igebs2d_	IGEBS2D
# define igebr2d_	IGEBR2D

#endif /*UpCase*/




F_VOID_FCT FTN_GESD2D STDC_PARAMS( 
	(int *ICONTXT, int *M, int *N, FDATA A[], int *LDA, 
	 int *RDEST, int *CDEST) 
);


F_VOID_FCT FTN_GERV2D STDC_PARAMS( 
	(int *ICONTXT, int *M, int *N, FDATA A[], int *LDA, 
	 int *RDEST, int *CDEST) 
);

F_VOID_FCT FTN_GEBS2D STDC_PARAMS( 
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, 
	 FDATA A[], int *LDA)
);

F_VOID_FCT FTN_GEBR2D STDC_PARAMS( 
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, 
	 FDATA A[], int *LDA, int *RSRC, int *CSRC)
);

F_VOID_FCT FTN_GSUM2D STDC_PARAMS(
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, 
	 FDATA A[], int *LDA, int *RDEST, int *CDEST)
);

F_VOID_FCT FTN_GAMX2D STDC_PARAMS(
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, FDATA A[], 
	 int *LDA, int *RA, int *CA, int *RCFLAG, int *RDEST, int *CDEST)
);

F_VOID_FCT FTN_GAMN2D STDC_PARAMS(
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, FDATA A[], 
	 int *LDA, int *RA, int *CA, int *RCFLAG, int *RDEST, int *CDEST)
);

F_VOID_FCT FTN_BLACS_GRIDINFO STDC_PARAMS(
        (int *ICONTXT, int *NPROW, int *NPCOL, int *MYPROW, int *MYPCOL)
);

F_VOID_FCT FTN_BLACS_BARRIER STDC_PARAMS( (int *ICONTXT, F_CHAR_T SCOPE ) );

F_VOID_FCT FTN_BLACS_ABORT STDC_PARAMS( (int *ICONTXT, int *ERRORNUM ) );

F_VOID_FCT FTN_BLACS_GET STDC_PARAMS( (int *ICONTXT, int *WHAT, int *VAL ) );

F_VOID_FCT FTN_BLACS_GRIDINIT STDC_PARAMS( 
        (int *ICONTXT, F_CHAR_T ORDER, int *NPROW, int *NPCOL)
);

double FTN_DWALLTIME00();

F_VOID_FCT FTN_IGEBS2D STDC_PARAMS( 
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, 
	 int A[], int *LDA)
);

F_VOID_FCT FTN_IGEBR2D STDC_PARAMS( 
	(int *ICONTXT, F_CHAR_T SCOPE, F_CHAR_T TOP, int *M, int *N, 
	 int A[], int *LDA, int *RSRC, int *CSRC)
);




#if FDATATYPE==SINGLE
# define C_GESD2D	Csgesd2d
# define C_GERV2D	Csgerv2d 
# define C_GEBS2D	Csgebs2d
# define C_GEBR2D	Csgebr2d
# define C_GSUM2D	Csgsum2d
# define C_GAMX2D	Csgamx2d
# define C_GAMN2D	Csgamn2d
#else
# define C_GESD2D	Cdgesd2d
# define C_GERV2D	Cdgerv2d 
# define C_GEBS2D	Cdgebs2d
# define C_GEBR2D	Cdgebr2d
# define C_GSUM2D	Cdgsum2d
# define C_GAMX2D	Cdgamx2d
# define C_GAMN2D	Cdgamn2d
#endif /*FDATATYPE*/
#define  C_BLACS_GRIDINFO	Cblacs_gridinfo
#define  C_BLACS_BARRIER	Cblacs_barrier
#define  C_BLACS_ABORT		Cblacs_abort
#define  C_BLACS_GET		Cblacs_get
#define  C_BLACS_GRIDINIT	Cblacs_gridinit
#define	 C_DWALLTIME00		Cdwalltime00
#define  C_BLACS_PINFO		Cblacs_pinfo
#define  C_IGEBS2D		Cigebs2d
#define  C_IGEBR2D		Cigebr2d


void C_GESD2D STDC_PARAMS(
	(int icontxt, int m, int n, FDATA A[], int LdA, 
	 int rdest, int cdest) 
);

void C_GERV2D STDC_PARAMS( 
	(int icontxt, int m, int n, FDATA A[], int LdA, 
	 int rdest, int cdest) 
);

void C_GEBS2D STDC_PARAMS( 
	(int icontxt, char *SCOPE, char *TOP, int m, int n, 
	 FDATA A[], int LdA)
);

void C_GEBR2D STDC_PARAMS( 
	(int icontxt, char *SCOPE, char *TOP, int m, int n, 
	 FDATA A[], int LdA, int rsrc, int csrc)
);

void C_GSUM2D STDC_PARAMS(
	(int icontxt, char *SCOPE, char *TOP, int m, int n, 
	 FDATA A[], int LdA, int rdest, int cdest)
);


void C_GAMX2D STDC_PARAMS(
	(int icontxt, char *SCOPE, char *TOP, int m, int n, FDATA A[], 
	 int LdA, int *RA, int *CA, int rcflag, int rdest, int cdest)
);

void C_GAMN2D STDC_PARAMS(
	(int icontxt, char *SCOPE, char *TOP, int m, int n, FDATA A[], 
	 int LdA, int *RA, int *CA, int rcflag, int rdest, int cdest)
);

void C_BLACS_GRIDINFO STDC_PARAMS(
        (int icontxt, int *nprow, int *npcol, int *myprow, int *mypcol)
);

void C_BLACS_BARRIER STDC_PARAMS( (int icontxt, char *SCOPE ) );

void C_BLACS_ABORT STDC_PARAMS( (int icontxt, int errornum ) );

void C_BLACS_GET STDC_PARAMS( (int icontxt, int what, int *VAL ) );

void C_BLACS_GRIDINIT STDC_PARAMS( 
        (int icontxt, char *ORDER, int nprow, int npcol)
);

double C_DWALLTIME00();

void C_IGEBS2D STDC_PARAMS( 
	(int icontxt, char *SCOPE, char *TOP, int m, int n, 
	 int A[], int LdA)
);

void C_IGEBR2D STDC_PARAMS( 
	(int icontxt, char *SCOPE, char *TOP, int m, int n, 
	 int A[], int LdA, int rsrc, int csrc)
);


#endif /*__FtnBLACS_INCL__*/
