/************************************************************************/
/*		FtnBLAS: C prototypes for limited Fortran cell BLAS 	*/ 
/************************************************************************/
/* SCCS INFO @(#)FtnBLAS.h 1.3         last modified P. Strazdins, 99/04/20
   first created: P. Strazdins 96/01/19
*/
/* compilation:	see F2C.h for macros controlling procedure renaming
 */
#ifndef __FtnBLAS_INCL__
#define __FtnBLAS_INCL__
   
 
 
#include "FDATASetUp.h"
#include "F2C.h"
   
#if FDATATYPE==SINGLE
# define FTN_ASUM        sasum_
# define FTN_DOT         sdot_
# define FTN_NRM2        snrm2_
# define FTN_AXPY        saxpy_
# define FTN_COPY        scopy_
# define FTN_IAMAX       isamax_
# define FTN_SCAL        sscal_
# define FTN_SWAP        sswap_
# define FTN_GEMV        sgemv_
# define FTN_GER         sger_
# define FTN_SYRK	 ssyrk_
# define FTN_GEMM        sgemm_
# define FTN_TRMM        strmm_
# define FTN_TRMV        strmv_
# define FTN_TRSM        strsm_
#elif FDATATYPE==DOUBLE
# define FTN_ASUM        dasum_
# define FTN_DOT         ddot_
# define FTN_NRM2        dnrm2_
# define FTN_AXPY        daxpy_   
# define FTN_COPY        dcopy_ 
# define FTN_IAMAX       idamax_
# define FTN_SCAL        dscal_   
# define FTN_SWAP        dswap_
# define FTN_GEMV        dgemv_
# define FTN_TRMV        dtrmv_
# define FTN_GER         dger_
# define FTN_SYRK	 dsyrk_
# define FTN_GEMM        dgemm_
# define FTN_TRMM        dtrmm_
# define FTN_TRSM        dtrsm_
#elif FDATATYPE==COMPLEX
# define FTN_ASUM        scasum_
# define FTN_DOT         cdotu_
# define FTN_NRM2        scnrm2_
# define FTN_AXPY        caxpy_   
# define FTN_COPY        ccopy_ 
# define FTN_IAMAX       icamax_
# define FTN_SCAL        cscal_   
# define FTN__SCAL       csscal_   
# define FTN_SWAP        cswap_
# define FTN_GEMV        cgemv_
# define FTN_TRMV        ctrmv_
# define FTN_GER         cgeru_
# define FTN_SYRK	 csyrk_
# define FTN_GEMM        cgemm_
# define FTN_TRMM        ctrmm_
# define FTN_TRSM        ctrsm_
#else
# define FTN_ASUM        dzasum_
# define FTN_DOT         zdotu_
# define FTN_NRM2        dznrm2_
# define FTN_AXPY        zaxpy_   
# define FTN_COPY        zcopy_ 
# define FTN_IAMAX       izamax_
# define FTN_SCAL        zscal_   
# define FTN__SCAL       zdscal_   
# define FTN_SWAP        zswap_
# define FTN_GEMV        zgemv_
# define FTN_TRMV        ztrmv_
# define FTN_GER         zgeru_
# define FTN_SYRK	 zsyrk_
# define FTN_GEMM        zgemm_
# define FTN_TRMM        ztrmm_
# define FTN_TRSM        ztrsm_
#endif /*FDATATYPE*/

#ifdef NoChange
#   define sasum_	sasum
#   define sdot_	sdot
#   define snrm2_	snrm2
#   define saxpy_	saxpy
#   define scopy_	scopy
#   define isamax_	isamax
#   define sscal_	sscal
#   define sswap_	sswap
#   define sgemv_	sgemv
#   define strmv_	strmv
#   define sger_	sger
#   define ssyrk_	ssyrk
#   define sgemm_	sgemm
#   define strmm_	strmm
#   define strsm_	strsm

#   define dasum_	dasum
#   define ddot_	ddot
#   define dnrm2_	dnrm2
#   define daxpy_	daxpy
#   define dcopy_	dcopy
#   define idamax_	idamax
#   define dscal_	dscal
#   define dswap_	dswap
#   define dgemv_	dgemv
#   define dtrmv_	dtrmv
#   define dger_	dger
#   define dsyrk_	dsyrk
#   define dgemm_	dgemm
#   define dtrmm_	dtrmm
#   define dtrsm_	dtrsm

#   define scasum_	scasum
#   define cdotu_	cdotu
#   define scnrm2	scnrm2
#   define caxpy_	caxpy
#   define ccopy_	ccopy
#   define icamax_	icamax
#   define cscal_	cscal
#   define csscal_	csscal
#   define cswap_	cswap
#   define cgemv_	cgemv
#   define ctrmv_	ctrmv
#   define cgeru_	cgeru
#   define csyrk_	csyrk
#   define cgemm_	cgemm
#   define ctrmm_	ctrmm
#   define ctrsm_	ctrsm

#   define dzasum_	dzasum
#   define zdotu_	zdotu
#   define dznrm2	dznrm2
#   define zaxpy_	zaxpy
#   define zcopy_	zcopy
#   define izamax_	izamax
#   define zscal_	zscal
#   define zdscal_	zdscal
#   define zswap_	zswap
#   define zgemv_	zgemv
#   define ztrmv_	ztrmv
#   define zger_	zgeru
#   define zsyrk_	zsyrk
#   define zgemm_	zgemm
#   define ztrmm_	ztrmm
#   define ztrsm_	ztrsm
#endif /*NOChange*/

#ifdef UpCase
#   define sasum_	SASUM
#   define sdot_	SDOT
#   define snrm2_	SNRM2
#   define saxpy_	SAXPY
#   define scopy_	SCOPY
#   define isamax_	ISAMAX
#   define sscal_	SSCAL
#   define sswap_	SSWAP
#   define sgemv_	SGEMV
#   define strmv_	STRMV
#   define sger_	SGER
#   define ssyrk_	SSYRK
#   define sgemm_	SGEMM
#   define strmm_	STRMM
#   define strsm_	STRSM

#   define dasum_	DASUM
#   define ddot_	DDOT
#   define dnrm2_	DNRM2
#   define daxpy_	DAXPY
#   define dcopy_	DCOPY
#   define idamax_	IDAMAX
#   define dscal_	DSCAL
#   define dswap_	DSWAP
#   define dgemv_	DGEMV
#   define dtrmv_	DTRMV
#   define dger_	DGER
#   define dsyrk_	DSYRK
#   define dgemm_	DGEMM
#   define dtrmm_	DTRMM
#   define dtrsm_	DTRSM

#   define scasum_	SCASUM
#   define cdotu_	CDOTU
#   define scnrm2_	SCNRM2
#   define caxpy_	CAXPY
#   define ccopy_	CCOPY
#   define icamax_	ICAMAX
#   define cscal_	CSCAL
#   define csscal_	CSSCAL
#   define cswap_	CSWAP
#   define cgemv_	CGEMV
#   define ctrmv_	CTRMV
#   define cgeru_	CGERU
#   define csyrk_	CSYRK
#   define cgemm_	CGEMM
#   define ctrmm_	CTRMM
#   define ctrsm_	CTRSM

#   define dzasum_	DZASUM
#   define zdotu_	ZDOTU
#   define dznrm2_	DZNRM2
#   define zaxpy_	ZAXPY
#   define zcopy_	ZCOPY
#   define izamax_	IZAMAX
#   define zscal_	ZSCAL
#   define zdscal_	ZDSCAL
#   define zswap_	ZSWAP
#   define zgemv_	ZGEMV
#   define ztrmv_	ZTRMV
#   define zgeru_	ZGERU
#   define zsyrk_	ZSYRK
#   define zgemm_	ZGEMM
#   define ztrmm_	ZTRMM
#   define ztrsm_	ZTRSM

#endif /*UpCase*/


#if (FDATATYPE < COMPLEX)

FDATA FTN_DOT STDC_PARAMS((int *N, FDATA X[], int *INCX, FDATA Y[], int *INCY));

#else	/* this is valid for Solaris but unknown for other platforms */

F_VOID_FCT FTN_DOT STDC_PARAMS((FDATA *v, int *N, FDATA X[], int *INCX, FDATA Y[], int *INCY));

#endif

FD_BASE FTN_NRM2 STDC_PARAMS((int *N, FDATA X[], int *INCX) );


FD_BASE FTN_ASUM STDC_PARAMS( (int *N, FDATA X[], int *INCX) );

int FTN_IAMAX STDC_PARAMS( (int *N, FDATA X[], int *INCX) );

F_VOID_FCT FTN_AXPY STDC_PARAMS(
	(int *N, FDATA *ALPHA, FDATA X[], int *INCX, FDATA Y[], int *INCY) 
);

F_VOID_FCT FTN_COPY STDC_PARAMS( 
	(int *N, FDATA X[], int *INCX, FDATA Y[], int *INCY) 
);

F_VOID_FCT FTN_SWAP STDC_PARAMS( 
	(int *N, FDATA X[], int *INCX, FDATA Y[], int *INCY) 
);

F_VOID_FCT FTN_SCAL STDC_PARAMS( 
	(int *N, FDATA *ALPHA, FDATA X[], int *INCX) 
);

F_VOID_FCT FTN__SCAL STDC_PARAMS( 
	(int *N, FD_BASE *ALPHA, FDATA X[], int *INCX) 
);

F_VOID_FCT FTN_GER STDC_PARAMS( 
	(int *M, int *N, FDATA *ALPHA, FDATA X[], int *INCX, 
	 FDATA Y[], int *INCY, FDATA A[], int *LDA) 
);

F_VOID_FCT FTN_GEMV STDC_PARAMS( 
	(F_CHAR_T TRANS, int *M, int *N, FDATA *ALPHA, FDATA A[], int *LDA, 
	 FDATA X[], int *INCX, FDATA *BETA, FDATA Y[], int *INCY) 
);

F_VOID_FCT FTN_TRMV STDC_PARAMS( 
	(F_CHAR_T UPLO, F_CHAR_T TRANS, F_CHAR_T Diag, int *N, 
	 FDATA A[], int *LDA, FDATA X[], int *INCX)
);

F_VOID_FCT FTN_SYRK STDC_PARAMS( 
	(F_CHAR_T UPLO, F_CHAR_T TRANS, int *N, int *K, 
	 FDATA *ALPHA, FDATA A[], int *LDA, FDATA *BETA, FDATA C[], int *LDC)
);

F_VOID_FCT FTN_GEMM STDC_PARAMS( 
	(F_CHAR_T TRANSA, F_CHAR_T TRANSB, int *M, int *N, int *K, 
	 FDATA *ALPHA, FDATA A[], int *LDA, FDATA B[], int *LDB, 
	 FDATA *BETA,  FDATA C[], int *LDC)
);

F_VOID_FCT FTN_TRSM STDC_PARAMS(
        (F_CHAR_T SIDE, F_CHAR_T UPLO, F_CHAR_T TRANSA, F_CHAR_T DIAG, 
        int *M, int *N, FDATA *ALPHA, FDATA A[], int *LDA, FDATA B[], int *LDB)
);      
                            
F_VOID_FCT FTN_TRMM STDC_PARAMS(
        (F_CHAR_T SIDE, F_CHAR_T UPLO, F_CHAR_T TRANSA, F_CHAR_T DIAG, 
        int *M, int *N, FDATA *ALPHA, FDATA A[], int *LDA, FDATA B[], int *LDB)
);                                          
                           
#endif /*__FtnBLAS_INCL__*/

