/************************************************************************/
/*	LocMat: definitions for cell matrix data structures		*/
/************************************************************************/
/* SCCS INFO @(#)LocMat.c 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 96/01/15
*/
#include "FDATASetUp.h"
#include "FDATAOps.h"
#include "LocMat.h"

LocMat MkLocMat( A, RInc, CInc )
  FDATA *A; int RInc, CInc;
{ LocMat M; LM_Init( M, A, RInc, CInc );
  return(M);
}  

LocMat LocSubMat( M, i, j )
  LocMat M; int i, j;
{ LM_ADR(M) = LM_Index(M, i, j);
  return(M);
}  

LocMat LocMatTrans( M )
  LocMat M;
{ SWAP(int, LM_RInc(M), LM_CInc(M));
  return(M);
}  

#include <stdio.h>
#include "FDAssert.h"

void MatPrint(Name, M, N, A)
  int M, N; char *Name; LocMat A;
{ int i, j, RIncA=LM_RInc(A), CIncA=LM_CInc(A); FDATA *Ax = LM_ADR(A);
  COMMON_ASSERT_TR(
    (TraceStr, "(%2s,%dx%d,a%d %d %d)", Name, M, N, FD_ADR(Ax), RIncA, CIncA),
    1, 0, "MatPrint", 5, TRACE_ALL
  );
  for (i=0; i < M && N>0; i++) {
    PrintLinePrefix();	
    if (i==0) 
      printf("%s ", Name);
    else 
      for (j=0; j < strlen(Name)+1; j++)
        putchar(' ');  	
    for (j=0; j < N; j++)
#if (FDATATYPE == SINGLE || FDATATYPE == DOUBLE)
      printf("%+1.3f ", Ax[i*RIncA+j*CIncA]);
#else  
      printf("%+1.3f,%+1.3f ", FD_REAL(Ax[i*RIncA+j*CIncA]) , 
             FD_IMAG(Ax[i*RIncA+j*CIncA]));
#endif /*FDATATYPE*/ 
    printf("\n");
  }
} /* MatPrint() */

