/************************************************************************/
/*                     MachineParams		                        */
/************************************************************************/
/* SCCS INFO @(#)MachineParams.c 1.1         last modified P. Strazdins, 98/12/24
   first created: P. Strazdins 92/01
*/
/* Implementation of modifieable DBLAS machine-dependent parameters.
 * The arrays are statically defined must be changed if the the values 
 * of the _NUM constants change or if NUM_MACH_PARAMS changes.
 */	
/************************************************************************/

#include "string.h"
#undef TUNE
#include "MachineParams.h"


/* these arrays should have exactly NUM_MACH_PARAMS entries,
   whose order corresponds to the value of the respective _NUM indices */ 
int MachParamVec[] = {
	CACHESIZE,			CACHE_ASSOC,
	CACHE_LINE_SIZE,		OPT_MSG_SIZE,
	MAX_DBLAS_WS_SIZE,		MIN_VECSIZE,
	INNER_VECSIZE,			OUTER_VECSIZE,
	MINOR_OUTER_VECSIZE,		K0_MINOR_OUTER_VECSIZE,
	MINOR_OUTER_VECSIZE_K0,		PAR_INNER_VECSIZE,
	PAR_INNER_VECSIZE_TRSM,		PAR_OUTER_VECSIZE,
	PAR_INNER_VECSIZE_TRSM_MIN,	LG_MEM_BANKS,
	MM_INNER_K,			FAST_STRIDE_MSG,
	MM_SCALE,			TLBSIZE
}; 		

static char *MnemVals[] = {
  	CACHESIZE_MNEM, 		CACHE_ASSOC_MNEM, 	
	CACHE_LINE_SIZE_MNEM,		OPT_MSG_SIZE_MNEM,
	MAX_DBLAS_WS_SIZE_MNEM,		MIN_VECSIZE_MNEM,
	INNER_VECSIZE_MNEM,		OUTER_VECSIZE_MNEM,
	MINOR_OUTER_VECSIZE_MNEM,	K0_MINOR_OUTER_VECSIZE_MNEM,
	MINOR_OUTER_VECSIZE_K0_MNEM,	PAR_INNER_VECSIZE_MNEM,
	PAR_INNER_VECSIZE_TRSM_MNEM,	PAR_OUTER_VECSIZE_MNEM,
	PAR_INNER_VECSIZE_TRSM_MIN_MNEM,	LG_MEM_BANKS_MNEM,
	MM_INNER_K_MNEM,		FAST_STRIDE_MSG_MNEM,
	MM_SCALE_MNEM,			TLBSIZE_MNEM
};

int MachParamVal( ParamMnem )
  char *ParamMnem;
{ int i=0;
  while (i < NUM_MACH_PARAMS && strcmp(ParamMnem, MnemVals[i])!=0)
    i++;
  if (i==NUM_MACH_PARAMS)
    i=-1;
  return(i);
} /* MachParamVal() */
