/************************************************************************/
/* TriMatUpdate: DBLAS Tri Mat Update (Multiply) alg			*/
/************************************************************************/
/* SCCS INFO @(#)TriMatUpdate.h 1.2         last modified P. Strazdins, 99/02/25
   first created: P. Strazdins 97/03
*/

#ifndef __TriMatUpdate_INCL__
#define __TriMatUpdate_INCL__
   
#include "LocMat.h"
#include "DistMat.h"

#if FDATATYPE==SINGLE
# define TriMatUpdate	DSTriMatUpdate
#elif FDATATYPE==DOUBLE
# define TriMatUpdate	DDTriMatUpdate
#elif FDATATYPE==COMPLEX
# define TriMatUpdate	DCTriMatUpdate
#else
# define TriMatUpdate	DZTriMatUpdate
#endif

void TriMatUpdate STDC_PARAMS( 
  (char UpLo, char Diag, int M, int N, FDATA *alpha, DistMat A, DistMat B)
);
/* pre:  all cells are executing TriMatUpdate with consistent
 *       UpLo, Diag M, N, alpha, A, & B;
 *       UpLoOK(UpLo); DiagOK(Diag); 0<= M, N
 * post: performs B := *alpha A B
 *       where A is of form UpLo with MxN B,
 *       if Diag=Unit, diagonal elements of A assumed unity and not accessed
 * notes: efficient for N<<M
 */

#endif /*__TriMatUpdate_INCL__*/

