/************************************************************************/
/*         DBLAS interface to P_AMAX() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_AMAX.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_AMAX=0;		/* to indicate if P_AMAX is linked in*/
#endif

void P_AMAX(n, Amax, indx, A, ia, ja, desc_A, inca)
  int *n;
  FDATA *Amax, A[];  			int *ia, *ja;
  int *indx, desc_A[], *inca;
{ int ParamErr = 0;			int Trans = PBRowVec(*inca, desc_A);
  DistMat dA;
  int NoOuterErrCheck_ = NoOuterErrCheck;
  int P0; 

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 8;
  else {      
    ParamErr = PDescChkConv(0, Trans,  *n, 1, A, *ia, *ja, desc_A, 7, &dA);
    P0 = d_P0(DM_DN(dA));
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,_,_,a%d,%d,%d,_,%d)", 
      *n, FD_ADR(A), *ia, *ja, *inca), 
    -ParamErr, "AMAX", 0
  );

  if (P0==0) {				/* A & B over same grid row or col */
    DistMat_RVAlloc(1);			/* ColVec() ensures result of D_AMAX()
    					   is kept within this scope */
    NoOuterErrCheck = DBLAS1_CHECK_FLAG;/* suppress checking in D_AMAX() */
    *indx = D_AMAX(*n, ColVec(dA), Amax) + (Trans? *ja: *ia);
    NoOuterErrCheck = NoOuterErrCheck_;
  }
  TRACE_EXIT;
} /* P_AMAX */


