/************************************************************************/
/*         DBLAS interface to P_ASUM() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_ASUM.c 1.2         last modified P. Strazdins, 99/05/03
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_ASUM=0;		/* to indicate if P_ASUM is linked in*/
#endif

void P_ASUM(n, Asum, A, ia, ja, desc_A, inca)
  int *n;
  FD_BASE *Asum; FDATA A[];  		int *ia, *ja;
  int desc_A[], *inca;
{ int ParamErr = 0;			int Trans = PBRowVec(*inca, desc_A);
  DistMat dA;
  int NoOuterErrCheck_ = NoOuterErrCheck;
  int P0; 

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 7;
  else {      
    ParamErr = PDescChkConv(0, Trans, *n, 1, A, *ia, *ja, desc_A, 6, &dA);
    P0 = d_P0(DM_DN(dA));
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,_,a%d,%d,%d,_,%d)", 
      *n, FD_ADR(A), *ia, *ja, *inca), 
    -ParamErr, "ASUM", 0
  );

  if (P0==0) {				/* A & B over same grid row or col */
    DistMat_RVAlloc(1);			/* ColVec() ensures result of D_ASUM()
    					   is kept within this scope */
    NoOuterErrCheck = DBLAS1_CHECK_FLAG;/* suppress checking in D_ASUM() */
    *Asum = D_ASUM(*n, ColVec(dA));
    NoOuterErrCheck = NoOuterErrCheck_; 
  }
  TRACE_EXIT;
} /* P_ASUM */


