/************************************************************************/
/*         DBLAS interface to P_AXPY() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_AXPY.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_AXPY=0;		/* to indicate if P_AXPY is linked in*/
#endif

void P_AXPY(n, alpha, A, ia, ja, desc_A, inca, B, ib, jb, desc_B, incb)
  int *n;
  FDATA *alpha, A[], B[];  			int *ia, *ja, *ib, *jb;
  int desc_A[], *inca, desc_B[], *incb;
{ int ParamErr = 0;			
  DistMat dA, dB;
  int NoOuterErrCheck_ = NoOuterErrCheck;

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 7;
  else if (!VIncOK(*incb, desc_B)) 	ParamErr = 12;
  else {      
    int TrA = PBRowVec(*inca, desc_A),	TrB = PBRowVec(*incb, desc_B);
    ParamErr = PDescChkConv(0, TrA, *n, 1, A, *ia, *ja, desc_A, 6,  &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrB, *n, 1, B, *ib, *jb, desc_B, 11, &dB);
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_DM(dB));  
      if (!AlignM)			ParamErr = 11;
    }
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,%1.1f,a%d,%d,%d,_,%d,a%d,%d,%d,_,%d)", 
      *n, *alpha, FD_ADR(A), *ia, *ja, *inca, FD_ADR(B),*ib, *jb, *incb), 
    -ParamErr, "AXPY", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;	/* suppress checking in D_AXPY() */
  D_AXPY(*n, *alpha, dA, dB);
  NoOuterErrCheck = NoOuterErrCheck_;

  TRACE_EXIT;
} /* P_AXPY */

