/************************************************************************/
/*         DBLAS interface to P_COPY() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_COPY.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_COPY=0;		/* to indicate if P_COPY is linked in*/
#endif

void P_COPY(n, A, ia, ja, desc_A, inca, B, ib, jb, desc_B, incb)
  int *n;
  FDATA A[], B[];  			int *ia, *ja, *ib, *jb;
  int desc_A[], *inca, desc_B[], *incb;
{ int ParamErr = 0;			
  DistMat dA, dB;
  int NoOuterErrCheck_ = NoOuterErrCheck;

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 6;
  else if (!VIncOK(*incb, desc_B)) 	ParamErr = 11;
  else {      
    int TrA = PBRowVec(*inca, desc_A),  TrB = PBRowVec(*incb, desc_B);
    ParamErr = PDescChkConv(0, TrA, *n, 1, A, *ia, *ja, desc_A, 5,  &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrB, *n, 1, B, *ib, *jb, desc_B, 10, &dB);
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_DM(dB));
      if (!AlignM)			ParamErr = 10;
    }
  }
  
  ERROR_CHECK_TR(
    (TraceStr, "(%d,a%d,%d,%d,_,%d,a%d,%d,%d,_,%d)", 
      *n, FD_ADR(A), *ia, *ja, *inca, FD_ADR(B), *ib, *jb, *incb), 
    -ParamErr, "COPY", 0
  );
  
  NoOuterErrCheck = DBLAS1_CHECK_FLAG;	/* suppress checking in D_COPY() */
  D_COPY(*n, dA, dB);
  NoOuterErrCheck = NoOuterErrCheck_;

  TRACE_EXIT;
} /* P_COPY */

