/************************************************************************/
/*         DBLAS interface to P_DOT() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_DOT.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_DOT=0;		/* to indicate if P_DOT is linked in*/
#endif

void P_DOT(n, Dot, A, ia, ja, desc_A, inca, B, ib, jb, desc_B, incb)
  int *n;
  FDATA *Dot, A[], B[];  			int *ia, *ja, *ib, *jb;
  int desc_A[], *inca, desc_B[], *incb;
{ int ParamErr = 0;			int Trans = PBRowVec(*inca, desc_A);
  DistMat dA, dB;
  int NoOuterErrCheck_ = NoOuterErrCheck;
  int P0; 

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 7;
  else if ((1-VIncOK(*incb, desc_B)) | (PBRowVec(*incb, desc_B)^Trans))	
  					ParamErr = 12;
  else {          
    int TrA = PBRowVec(*inca, desc_A),  TrB = PBRowVec(*incb, desc_B);
    ParamErr = PDescChkConv(0, TrA, *n, 1, A, *ia, *ja, desc_A, 6,  &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrB, *n, 1, B, *ib, *jb, desc_B, 11, &dB);
    P0 = d_P0(DM_DN(dA));
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_DM(dB));
      if (!AlignM || P0 != d_P0(DM_DN(dB))) ParamErr = 11;
    }
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,_,a%d,%d,%d,_,%d,a%d,%d,%d,_,%d)", 
      *n, FD_ADR(A), *ia, *ja, *inca, FD_ADR(B),*ib, *jb, *incb), 
    -ParamErr, "DOT", 0
  );

  if (P0==0) {				/* A & B over same grid row or col */
    DistMat_RVAlloc(2);			/* ColVec() ensures result of D_DOT()
    					   is kept within this scope */
    NoOuterErrCheck = DBLAS1_CHECK_FLAG;/* suppress checking in D_DOT() */
    *Dot = D_DOT(*n, ColVec(dA), ColVec(dB));
    NoOuterErrCheck = NoOuterErrCheck_;
  }
  TRACE_EXIT;
} /* P_DOT */

