/************************************************************************/
/*         DBLAS interface to P_ELGET() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_ELGET.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 98/01
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_ELGET=0;		/* to indicate if P_ELGET is linked in*/
#endif

void P_ELGET(FScope, FTop, Aij, A, ia, ja, desc_A)
  F_CHAR_T FScope, FTop;
  FDATA *Aij, A[];  			int *ia, *ja;
  int desc_A[];
{ int ParamErr = 0;			
  DistMat dA;
  int NoOuterErrCheck_ = NoOuterErrCheck;
  DistMat_RVAlloc(1);		
  char *Scope = F2C_CHAR(FScope), *Top = F2C_CHAR(FTop);
  
  ParamErr = PDescChkConv(0, 0, 1, 1, A, *ia, *ja, desc_A, 7, &dA);
    
  ERROR_CHECK_TR(
    (TraceStr, "(%c,%c,_a%d,%d,%d,_)", *Scope, *Top, FD_ADR(A), *ia, *ja), 
     -ParamErr, "ELGET", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;/* suppress checking in D_GetElt() */
  if (*Scope == Row) {
    if (d_P0(DM_D0(dA))==0) 	
      *Aij = D_GetElt(RowVec(dA));
  } else if (*Scope == Col) {
    if (d_P0(DM_D1(dA))==0) 	
      *Aij = D_GetElt(ColVec(dA));
  } else
    *Aij = D_GetElt(dA); 	    
  NoOuterErrCheck = NoOuterErrCheck_;
  
  TRACE_EXIT;
} /* P_ELGET */
