/************************************************************************/
/*         DBLAS interface to P_ELSET() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_ELSET.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 98/01
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_ELSET=0;		/* to indicate if P_ELSET is linked in*/
#endif

void P_ELSET(A, ia, ja, desc_A, Aij)
  FDATA *Aij, A[];  			int *ia, *ja;
  int desc_A[];
{ int ParamErr = 0;			
  DistMat dA;
  
  ParamErr = PDescChkConv(0, 0, 1, 1, A, *ia, *ja, desc_A, 4, &dA);
    
  ERROR_CHECK_TR(
    (TraceStr, "(a%d,%d,%d,_,%.2f)", FD_ADR(A), *ia, *ja, *Aij), 
     -ParamErr, "ELSET", 0
  );

  if (!d_P0(DM_D0(dA)) && !d_P0(DM_D1(dA)))
    *LM_ADR(DM_Loc(dA)) = *Aij;
          
  TRACE_EXIT;
} /* P_ELSET */
