/************************************************************************/
/*         DBLAS interface to  P_GEQR2() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_GEQR2.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "ScaLAPACKMisc.h"

#ifndef ALTNAMES
static int UseDBLAS_P_GEQR2=0;		/* to indicate if  P_GEQR2 is linked in*/
#endif

void P_GEQR2( m, n, A, ia, ja, desc_A, Tau, Work, lwork, info )
  int *m, *n;
  FDATA A[], Tau[], Work[];  		int *ia, *ja;
  int desc_A[], *lwork, *info;
{ int ParamErr = 0;
  DistMat dA;
  int tj;
  
  if (!DimOK(*m))                       ParamErr = 1;
  else if (!DimOK(*n))                  ParamErr = 2;
  else {
    ParamErr = PDescChkConv(0, 0, *m, *n, A, *ia, *ja, desc_A, 6, &dA);
  }

  ERROR_CHECK_TR(
    (TraceStr, "(%d,%d,a%d,%d,%d,_,a%d,_,%d,_)",
     *m, *n, FD_ADR(A), *ia, *ja, FD_ADR(Tau), *lwork),
    -ParamErr, "GEQR2", 0
  );

  /* note: Work, lwork are ignored here; also info */
     
  tj = (LM_ADR(DM_Loc(dA)) - A) / desc_A[LLD_];
                                        /* must get corresp local offset to j
  					   to align with A */
  TauRowRep = 1;			/* use Tau as a  row-replicated vector*/
  D_GEQF2(*m, *n, dA, &Tau[tj]);
  
  TRACE_EXIT;  
} /*  P_GEQR2 */


