/************************************************************************/
/*         DBLAS interface to P_GEQRF() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_GEQRF.c 1.2         last modified P. Strazdins, 99/05/03
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "MachineParams.h" 
#include "D_LAPACK.h"
#include "ScaLAPACKMisc.h"

#ifndef ALTNAMES
static int UseDBLAS_P_GEQRF=0;		/* to indicate if P_GEQRF is linked in*/
#endif

void P_GEQRF( m, n, A, ia, ja, desc_A, Tau, Work, lwork, info )
  int *m, *n;
  FDATA A[], Tau[], Work[];  		int *ia, *ja;
  int desc_A[], *lwork, *info;
{ int ParamErr = 0;
  DistMat dA;
  
  int w;

  if (!DimOK(*m))                       ParamErr = 1;
  else if (!DimOK(*n))                  ParamErr = 2;
  else {
    ParamErr = PDescChkConv(0, 0, *m, *n, A, *ia, *ja, desc_A, 6, &dA);
  }

  /* note: Work, lwork are ignored here; also info */

  ERROR_CHECK_TR(
    (TraceStr, "(%d,%d,a%d,%d,%d,_,a%d,_,%d,_)",
     *m, *n, FD_ADR(A), *ia, *ja, FD_ADR(Tau), *lwork),
    -ParamErr, "GEQRF", 0
  );

  w = DILAENV(sizeof(FDATA), "SYTRF", MachParamVec, desc_A[ MB_ ], 
	      d_P(DM_D0(dA)), d_P(DM_D1(dA)));
#if 0
  if (w <= 0 ) w = desc_A[ MB_ ];
  else w = MIN(*m, *n);
#endif

  TauRowRep = 1;			/* use Tau as a  row-replicated vector*/
  D_GEQRF(*m, *n, dA, Tau, w);
  
  TRACE_EXIT;    
} /* P_GEQRF */

