/************************************************************************/
/*         DBLAS interface to P_GER() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_GER.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "GenMult.h"

#ifndef ALTNAMES
static int UseDBLAS_P_GER=0;		/* to indicate if P_GER is linked in*/
#endif

void P_GER(m, n, alpha, A, ia, ja, desc_A, inca,
           B, ib, jb, desc_B, incb, C, ic, jc, desc_C )              
  int *m, *n;
  FDATA *alpha, A[], B[], C[];  	int *ia, *ja, *ib, *jb, *ic, *jc;
  int desc_A[], *inca, desc_B[], *incb, desc_C[];
{ int ParamErr = 0;			
  DistMat dA, dB, dC;

  if (!DimOK(*m))			ParamErr = 1; 
  else if (!DimOK(*n))			ParamErr = 2; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 8;
  else if (!VIncOK(*incb, desc_B))	ParamErr = 13;
  else {      
    int TrA = PBRowVec(*inca, desc_A),	TrB = PBColVec(*incb, desc_B);
    ParamErr = PDescChkConv(0, 0,   *m, *n, C, *ic, *jc, desc_C, 17, &dC);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrA, *m,  1, A, *ia, *ja, desc_A,  7, &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(2, TrB,  1, *n, B, *ib, *jb, desc_B, 12, &dB);
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_D0(dC));
      int AlignN = Dim_BCompat(DM_DN(dB), DM_D1(dC));
      if (!AlignM)			ParamErr = 7;
      else if (!AlignN)			ParamErr = 12;
    }
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,%d,,%1.1f,a%d,%d,%d,_,%d,a%d,%d,%d,_,%d,a%d,%d,%d,_)", 
      *m, *n, *alpha, FD_ADR(A), *ia, *ja, *inca,
      FD_ADR(B),*ib, *jb, *incb, FD_ADR(C), *ic, *jc), 
    -ParamErr, "GER", 0
  );

  alpha = PBalphaval(alpha);		
  DistRankKMult(*m, *n, 1, alpha, dA, dB, NULL, dC);

  TRACE_EXIT;
} /* P_GER */

