/************************************************************************/
/*         DBLAS interface to P_POTRF() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_POTRF.c 1.2         last modified P. Strazdins, 99/05/03
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "MachineParams.h" 
#include "D_LAPACK.h"
#include "ScaLAPACKMisc.h"

#ifndef ALTNAMES
static int UseDBLAS_P_POTRF=0;		/* to indicate if P_POTRF is linked in*/
#endif

void P_POTRF( FUpLo, n, A, ia, ja, desc_A, info )
  F_CHAR_T FUpLo; 		int *n;
  FDATA A[];  			int *ia, *ja;
  int desc_A[], *info;
{ int ParamErr = 0;
  DistMat dA;
  char *UpLo = F2C_CHAR(FUpLo); 
  int w;

  if (!DimOK(*n))                       ParamErr = 1;
  else if (!UpLoOK(*UpLo) || UpperCase(*UpLo)!=Lower)              ParamErr = 2;
  else {
    ParamErr = PDescChkConv(0, 0, *n, *n, A, *ia, *ja, desc_A, 6, &dA);
  }

  ERROR_CHECK_TR(
    (TraceStr, "(%c,%d,a%d,%d,%d)",
     *UpLo, *n, FD_ADR(A), *ia, *ja ),
    -ParamErr, "POTRF", 0
  );

  
  w = DILAENV(sizeof(FDATA), "SYTRF", MachParamVec, desc_A[ MB_ ], 
	      d_P(DM_D0(dA)), d_P(DM_D1(dA)));
  /*getoptw_( &w );*/
#if 0
  if (w <= 0 ) w = desc_A[ MB_ ];
  else w = *n;
#endif

  D_POTRF(*n, dA, w);
  
  TRACE_EXIT;    
} /* P_POTRF */

