/************************************************************************/
/*         DBLAS interface to P_SCAL() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_SCAL.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SCAL=0;		/* to indicate if P_SCAL is linked in*/
#endif

void P_SCAL(n, alpha, A, ia, ja, desc_A, inca)
  int *n;
  FDATA *alpha, A[];  			int *ia, *ja;
  int desc_A[], *inca;
{ int ParamErr = 0;			int Trans = PBRowVec(*inca, desc_A);
  DistMat dA;
  int NoOuterErrCheck_ = NoOuterErrCheck;

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 7;
  else {      
    ParamErr = PDescChkConv(0, Trans,  *n, 1, A, *ia, *ja, desc_A, 6, &dA);
  }
  
  ERROR_CHECK_TR(
    (TraceStr, "(%d,%1.1f,a%d,%d,%d,_,%d)", 
      *n, *alpha, FD_ADR(A), *ia, *ja, *inca), 
    -ParamErr, "SCAL", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;	/* suppress checking in D_SCAL() */
  D_SCAL(*n, *alpha, dA);
  NoOuterErrCheck = NoOuterErrCheck_;

  TRACE_EXIT;
} /* P_SCAL */

