/************************************************************************/
/*         DBLAS interface to P_SWAP() 					*/
/************************************************************************/
/* SCCS INFO @(#)P_SWAP.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SWAP=0;		/* to indicate if P_SWAP is linked in*/
#endif

void P_SWAP(n, A, ia, ja, desc_A, inca, B, ib, jb, desc_B, incb)
  int *n;
  FDATA A[], B[];  			int *ia, *ja, *ib, *jb;
  int desc_A[], *inca, desc_B[], *incb;
{ int ParamErr = 0;			int Trans = PBRowVec(*inca, desc_A);
  DistMat dA, dB;
  int NoOuterErrCheck_ = NoOuterErrCheck;

  if (!DimOK(*n))			ParamErr = 1; 
  else if (!VIncOK(*inca, desc_A))	ParamErr = 6;
  else if ((1-VIncOK(*incb, desc_B)) | (PBRowVec(*incb, desc_B)^Trans))	
  					ParamErr = 11;
  else {      
    ParamErr = PDescChkConv(0, Trans, *n, 1, A, *ia, *ja, desc_A, 5,  &dA);
    if (!ParamErr)
      ParamErr = PDescChkConv(1, Trans, *n, 1, B, *ib, *jb, desc_B, 10, &dB);
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_DM(dB));
      if (!AlignM)			ParamErr = 10;
    }
  }
    
  ERROR_CHECK_TR(
    (TraceStr, "(%d,a%d,%d,%d,_,%d,a%d,%d,%d,_,%d)", 
      *n, FD_ADR(A), *ia, *ja, *inca, FD_ADR(B),*ib, *jb, *incb), 
    -ParamErr, "SWAP", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;	/* suppress checking in D_SWAP() */
  D_SWAP(*n, dA, dB);
  NoOuterErrCheck = NoOuterErrCheck_;

  TRACE_EXIT;
} /* P_SWAP */

