/************************************************************************/
/*         DBLAS interface to P_SYR()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_SYR.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "SYRKMult.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SYR=0;		/* to indicate if P_SYR is linked in*/
#endif

void P_SYR (FUpLo, n, alpha, A, ia, ja, desc_A, inca, 
	    C, ic, jc, desc_C )
  F_CHAR_T FUpLo;  				int *n;
  FDATA *alpha, A[], C[];  		int *ia, *ja, *ic, *jc;
  int desc_A[], *inca, desc_C[];
{ char *UpLo = F2C_CHAR(FUpLo);
  char UpLoC = UpperCase(*UpLo); 
  int ParamErr = 0;
  DistMat dA, dC;

  if (!UpLoOK(UpLoC)) 			ParamErr = 1;    
  else if (!DimOK(*n)) 			ParamErr = 2;   
  else if (!VIncOK(*inca, desc_A))      ParamErr = 8;
  else {
    int TrA = PBRowVec(*inca, desc_A);
    ParamErr = PDescChkConv(0, 0,   *n, *n, C, *ic, *jc, desc_C, 12, &dC);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrA, *n,  1, A, *ia, *ja, desc_A,  7, &dA);

    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_D0(dC));  
      if (!AlignM) 			ParamErr = 7;
      else if (!Dim_BCompat(DM_D0(dC), DM_D1(dC)))	ParamErr = 12;
    }
  }
            
  ERROR_CHECK_TR(
    (TraceStr, "(%c,%d,%1.1f,a%d,%d,%d,_,%d,a%d,%d,%d,_)", 
     *UpLo, *n, *alpha, FD_ADR(A), *ia, *ja, *inca, FD_ADR(C), *ic, *jc),
    -ParamErr, "SYR", 0
  );


  alpha = PBalphaval(alpha);            
  DistSYRKMult(*n, 1, alpha, dA, NULL, UpLoC, dC);
  TRACE_EXIT;
}  /* P_SYR()*/

