/************************************************************************/
/*         DBLAS interface to P_SYR2()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_SYR2.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "SYR2KMult.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SYR2=0;		/* to indicate if P_SYR2 is linked in*/
#endif

void P_SYR2 (FUpLo, n, alpha, A, ia, ja, desc_A, inca, B, ib, jb, desc_B, incb,
	     C, ic, jc, desc_C)
  F_CHAR_T FUpLo;            	   	int *n;
  FDATA *alpha, A[], B[], C[];   	int *ia, *ja, *ib, *jb, *ic, *jc;
  int desc_A[], *inca, desc_B[], *incb, desc_C[];
{ char *UpLo = F2C_CHAR(FUpLo);
  int Trans = PBRowVec(*inca, desc_A), 	UpLoC = UpperCase(*UpLo); 
  int ParamErr = 0;		
  DistMat dA, dB, dC;  
         
  if (!UpLoOK(UpLoC)) 			ParamErr = 1;
  else if (!DimOK(*n)) 			ParamErr = 2;
  else if (!VIncOK(*inca, desc_A))      ParamErr = 8;
  else if ((1-VIncOK(*incb, desc_B)) | (PBRowVec(*incb, desc_B)^Trans))      
  					ParamErr = 13;
  else {
    ParamErr = PDescChkConv(0, 0,     *n, *n, C, *ic, *jc, desc_C, 17, &dC);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, Trans, *n,  1, A, *ia, *ja, desc_A,  7, &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(2, Trans, *n,  1, B, *ib, *jb, desc_B, 12, &dB);

    if (ParamErr==0) {             	      
      int AlignM = Dim_BCompat(DM_DM(dA), DM_D0(dC));
      int AlignN = Dim_BCompat(DM_DM(dB), DM_D0(dC));  
      if (!AlignM) 			ParamErr = 7;
      else if (!AlignN)			ParamErr = 13;	
      else if (!Dim_BCompat(DM_D0(dC), DM_D1(dC))) ParamErr = 18;
    }
  }
    
  ERROR_CHECK_TR(
      (TraceStr, "(%c,%d,%1.1f,a%d,%d,%d,_,a%d,%d,%d,_,a%d,%d,%d,_)",
       *UpLo, *n, *alpha, FD_ADR(A), *ia, *ja, *inca,
       FD_ADR(B), *ib, *jb, *incb, FD_ADR(C), *ic, *jc),
       -ParamErr, "SYR2", 0
  );

  alpha = PBalphaval(alpha);            
  DistSYR2KMult(*n, 1, alpha, dA, dB, NULL, UpLoC, dC);
  TRACE_EXIT;
} /* D_SYR2()*/


