/************************************************************************/
/*         DBLAS interface to P_SYR2K()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_SYR2K.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "SYR2KMult.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SYR2K=0;		/* to indicate if P_SYR2K is linked in*/
#endif

void P_SYR2K (FUpLo, FTrans, n, k, alpha, A, ia, ja, desc_A, B, ib, jb, desc_B, 
	     beta,  C, ic, jc, desc_C )
  F_CHAR_T FUpLo, FTrans;		int *n, *k;
  FDATA *alpha, A[], B[], *beta, C[];   int *ia, *ja, *ib, *jb, *ic, *jc;
  int desc_A[], desc_B[], desc_C[];
{ char *UpLo = F2C_CHAR(FUpLo),		*Trans = F2C_CHAR(FTrans);
  char TransAB = UpperCase(*Trans), 	UpLoC = UpperCase(*UpLo); 
  int ParamErr = 0;		
  DistMat dA, dB, dC;
         
  if (!UpLoOK(UpLoC)) 			ParamErr = 1;
  else if (!TransOK(TransAB)) 		ParamErr = 2;
  else if (!DimOK(*n)) 			ParamErr = 3;
  else if (!DimOK(*k)) 			ParamErr = 4;
  else {
    int Trans = TransAB!=NoTranspose;
    ParamErr = PDescChkConv(0, 0,     *n, *n, C, *ic, *jc, desc_C, 18, &dC);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, Trans, *n, *k, A, *ia, *ja, desc_A,  9, &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(2, Trans, *n, *k, B, *ib, *jb, desc_B, 13, &dB);
    if (ParamErr==0) {             	      
      int AlignM = Dim_BCompat(DM_DM(dA), DM_D0(dC));
      int AlignN = Dim_BCompat(DM_DM(dB), DM_D0(dC));
      if (!AlignM)                      ParamErr = 9;
      else if (!AlignN)                 ParamErr = 13;
      else if (!Dim_BCompat(DM_D0(dC), DM_D1(dC))) ParamErr = 18;
    }
  }
    
  ERROR_CHECK_TR(
      (TraceStr, "(%c,%c,%d,%d,%1.1f,a%d,%d,%d,_,a%d,%d,%d,_,a%d,%d,%d,_)",
       *UpLo, *Trans, *n, *k, *alpha, FD_ADR(A), *ia, *ja, 
       FD_ADR(B), *ib, *jb, *beta, FD_ADR(C), *ic, *jc),
       -ParamErr, "SYR2K", 0
  );

  alpha = PBalphaval(alpha);           beta = PBbetaval(beta);
  DistSYR2KMult(*n, *k, alpha, dA, dB, beta, UpLoC, dC);
  TRACE_EXIT;
} /* D_SYR2K()*/


