/************************************************************************/
/*         DBLAS interface to P_SYRK()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_SYRK.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "SYRKMult.h"

#ifndef ALTNAMES
static int UseDBLAS_P_SYRK=0;		/* to indicate if P_SYRK is linked in*/
#endif

void P_SYRK (FUpLo, FTrans, n, k, alpha, A, ia, ja, desc_A, beta, 
	     C, ic, jc, desc_C )
  F_CHAR_T FUpLo, FTrans; 		int *n, *k;
  FDATA *alpha, A[], *beta, C[];  	int *ia, *ja, *ic, *jc;
  int desc_A[], desc_C[];
{ char *UpLo = F2C_CHAR(FUpLo), 	*Trans =  F2C_CHAR(FTrans);
  char TransA = UpperCase(*Trans), 	UpLoC = UpperCase(*UpLo); 
  int ParamErr = 0;
  DistMat dA, dC;

  if (!UpLoOK(UpLoC)) 			ParamErr = 1;    
  else if (!TransOK(TransA)) 		ParamErr = 2;
  else if (!DimOK(*n)) 			ParamErr = 3;   
  else if (!DimOK(*k)) 			ParamErr = 4;
  else {
    int TrA = TransA!=NoTranspose; 	 
    ParamErr = PDescChkConv(0, 0,   *n, *n, C, *ic, *jc, desc_C, 14, &dC);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrA, *n, *k, A, *ia, *ja, desc_A,  9, &dA);
            
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_D0(dC));
      if (!AlignM) 			ParamErr = 9;
      else if (!Dim_BCompat(DM_D0(dC), DM_D1(dC)))	ParamErr = 14;
    }
  }
            
  ERROR_CHECK_TR(
    (TraceStr, "(%c,%c,%d,%d,%1.1f,a%d,%d,%d,_,%1.1f,a%d,%d,%d,_)", 
     *UpLo, *Trans, *n, *k, *alpha, FD_ADR(A), *ia, *ja, *beta, FD_ADR(C), *ic, *jc), 
    -ParamErr, "SYRK", 0
  );


  alpha = PBalphaval(alpha);            beta = PBbetaval(beta);
  DistSYRKMult(*n, *k, alpha, dA, beta, UpLoC, dC);
  TRACE_EXIT;
}  /* P_SYRK()*/

