/************************************************************************/
/*         DBLAS interface to P_TRAN()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_TRAN.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 96/10
 */

#include "PBLASCheck.h"
#include "D_BLAS.h"

#ifndef ALTNAMES
static int UseDBLAS_P_TRAN=0;		/* to indicate if P_TRAN is linked in*/
#endif

void P_TRAN (m, n, alpha, A, ia, ja, desc_A, beta, 
	     C, ic, jc, desc_C )
  int *m, *n;
  FDATA *alpha, A[], *beta, C[];  	int *ia, *ja, *ic, *jc;
  int desc_A[], desc_C[];
{ int ParamErr = 0;
  DistMat dA, dC;
  int NoOuterErrCheck_ = NoOuterErrCheck;
  
  if (!DimOK(*m)) 			ParamErr = 1;   
  else if (!DimOK(*n)) 			ParamErr = 2;
  else {
    ParamErr = PDescChkConv(0, 1, *m, *n, A, *ia, *ja, desc_A,  7, &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, 0, *m, *n, C, *ic, *jc, desc_C, 12, &dC);
    if (ParamErr==0) {
      int AlignM = Dim_BCompat(DM_DM(dA), DM_DM(dC));
      int AlignN = Dim_BCompat(DM_DN(dA), DM_DN(dC));            	
      if ((1-AlignM)|(1-AlignN)) 	ParamErr = 7;
    }
  }
            
  ERROR_CHECK_TR(
    (TraceStr, "(%d,%d,%1.1f,a%d,%d,%d,_,%1.1f,a%d,%d,%d,_)", 
     *m, *n, *alpha, FD_ADR(A), *ia, *ja, *beta, FD_ADR(C), *ic, *jc), 
    -ParamErr, "TRAN", 0
  );

  NoOuterErrCheck = DBLAS1_CHECK_FLAG;  /* suppress checking in D_ScaleAdd() */
  D_ScaleAdd(*m, *n, *alpha, dA, *beta, dC); 
  NoOuterErrCheck = NoOuterErrCheck_;
  TRACE_EXIT;
}  /* P_TRAN()*/

