/************************************************************************/
/*         DBLAS interface to P_TRSV()                                  */
/************************************************************************/
/* SCCS INFO @(#)P_TRSV.c 1.1         last modified P. Strazdins, 99/04/23
   first created: P. Strazdins 97/04
 */

#include "PBLASCheck.h"
#include "TriMatSolve.h"

#ifndef ALTNAMES
static int UseDBLAS_P_TRSV=0;		/* to indicate if P_TRSV is linked in*/
#endif


void P_TRSV( FUpLo, FTransA, FDiag, n, A, ia, ja, desc_A,
             B, ib, jb, desc_B, incb )              
  F_CHAR_T FUpLo, FTransA, FDiag; 	int *n;
  FDATA A[], B[];			int *ia, *ja, *ib, *jb; 
  int desc_A[], desc_B[], *incb;
{ char *UpLo = F2C_CHAR(FUpLo),
       *TransA = F2C_CHAR(FTransA),     *Diag = F2C_CHAR(FDiag);
  char Trans = UpperCase(*TransA), 	UpLoA = UpperCase(*UpLo), 
       DiagA = UpperCase(*Diag);
  int ParamErr;
  DistMat dA, dB;
  int TrB = PBRowVec(*incb, desc_B);

  if (!UpLoOK(UpLoA))			ParamErr = 1;
  else if (!TransOK(Trans))		ParamErr = 2;
  else if (!DiagOK(DiagA))		ParamErr = 3;
  else if (!DimOK(*n))			ParamErr = 4;
  else if (!VIncOK(*incb, desc_B))	ParamErr = 13;
  else {
    int TrA = (Trans!=NoTranspose);
    ParamErr = PDescChkConv(0, TrA, *n, *n, A, *ia, *ja, desc_A,  8, &dA);
    if (ParamErr==0)
      ParamErr = PDescChkConv(1, TrB, *n,  1, B, *ib, *jb, desc_B, 12, &dB);
    if ((ParamErr==0) && (1-Dim_BCompat(DM_DM(dB), DM_DN(dA))))	
    					ParamErr = 12;
  }
  
  ERROR_CHECK_TR(   
    (TraceStr, "(%c,%c,%c,%d,a%d,%d,%d,_,a%d,%d,%d,_,%d)",
     *UpLo, *TransA, *Diag, *n, FD_ADR(A), *ia, *ja, FD_ADR(B), *ib, *jb, *incb),
    -ParamErr, "TRSV", 0
  );
    
  if (TrB)
    UpLoA = TransForm(UpLoA);
  TriMatSolve1Blk(UpLoA, DiagA, *n, 1, &FD_1, dA, dB);
      
  TRACE_EXIT;
} /* P_TRSV() */

