/************************************************************************/
/*	common macro definitions and headers for files implementing 	*
 *      the DLAPACK interface to selected ScaLAPACK routines. 		*
/************************************************************************/
/* SCCS INFO @(#)ScaLAPACKMisc.h 1.3         last modified P. Strazdins, 00/08/01
   first created: P. Strazdins 96/12
*/
    
#ifndef __ScaLAPACKMisc_INCL__
#define __ScaLAPACKMisc_INCL__

#ifndef ALTNAMES                        /* use standard names */
#if (FDATATYPE==SINGLE)         /*define procedure identifiers and names*/
# define P_GETRF        psgetrf_
# define P_GEQRF        psgeqrf_
# define P_POTRF        pspotrf_
# define P_GEQR2        psgeqr2_
# define P_LARFT	pslarft_
# define P_LARFB	pslarfb_
# define P_SYTRF        pssytrf_
# define P_SYTRS        pssytrs_
# define P_GETRS        psgetrs_
#elif (FDATATYPE==DOUBLE)
# define P_GETRF        pdgetrf_
# define P_GEQRF        pdgeqrf_
# define P_POTRF        pdpotrf_
# define P_GEQR2        pdgeqr2_
# define P_LARFT	pdlarft_
# define P_LARFB	pdlarfb_
# define P_SYTRF        pdsytrf_
# define P_SYTRS        pdsytrs_
# define P_GETRS        pdgetrs_
#elif (FDATATYPE==COMPLEX)
# define P_GETRF        pcgetrf_
# define P_GEQRF        pcgeqrf_
# define P_POTRF        pcpotrf_
# define P_GEQR2        pcgeqr2_
# define P_LARFT	pclarft_
# define P_LARFB	pclarfb_
# define P_SYTRF        pcsytrf_
# define P_SYTRS        pcsytrs_
# define P_GETRS        pcgetrs_
#else
# define P_GETRF        pzgetrf_
# define P_GEQRF        pzgeqrf_
# define P_POTRF        pzpotrf_
# define P_GEQR2        pzgeqr2_
# define P_LARFT	pzlarft_
# define P_LARFB	pzlarfb_
# define P_SYTRF        pzsytrf_
# define P_SYTRS        pzsytrs_
# define P_GETRS        pzgetrs_
#endif /*FDATATYPE*/

#ifdef NoChange
#define psgetrf_	psgetrf
#define psgeqrf_	psgeqrf
#define pspotrf_	pspotrf
#define psgeqr2_	psgeqr2
#define pslarfb_	pslarfb
#define pslarft_	pslarft
#define pssytrf_	pssytrf
#define pssytrs_	pssytrs
#define psgetrs_	psgetrs

#define pdgetrf_	pdgetrf
#define pdgeqrf_	pdgeqrf
#define pdpotrf_	pdpotrf
#define pdgeqr2_	pdgeqr2
#define pdlarft_	pdlarft
#define pdlarfb_	pdlarfb
#define pdsytrf_	pdsytrf
#define pdsytrs_	pdsytrs
#define pdgetrs_	pdgetrs

#define pcgetrf_	pcgetrf
#define pcgeqrf_	pcgeqrf
#define pcpotrf_	pcpotrf
#define pcgeqr2_	pcgeqr2
#define pclarfb_	pclarfb
#define pclarft_	pclarft
#define pcsytrf_	pcsytrf
#define pcsytrs_	pcsytrs
#define pcgetrs_	pcgetrs

#define pzgetrf_	pzgetrf
#define pzgeqrf_	pzgeqrf
#define pzpotrf_	pzpotrf
#define pzgeqr2_	pzgeqr2
#define pzlarft_	pzlarft
#define pzlarfb_	pzlarfb
#define pzsytrf_	pzsytrf
#define pzsytrs_	pzsytrs
#define pzgetrs_	pzgetrs
#endif /* NoChange */

#ifdef UpCase
#define psgetrf_	PSGETRF
#define psgeqrf_	PSGEQRF
#define pspotrf_	PSPOTRF
#define psgeqr2_	PSGEQR2
#define pslarfb_	PSLARFB
#define pslarft_	PSLARFT
#define pssytrf_	PSSYTRF
#define pssytrs_	PSSYTRS
#define psgetrs_	PSGETRS

#define pdgetrf_	PDGETRF
#define pdgeqrf_	PDGEQRF
#define pdpotrf_	PDPOTRF
#define pdgeqr2_	PDGEQR2
#define pdlarft_	PDLARFT
#define pdlarfb_	PDLARFB
#define pdsytrf_	PDSYTRF
#define pdsytrs_	PDSYTRS
#define pdgetrs_	PDGETRS

#define pcgetrf_	PCGETRF
#define pcgeqrf_	PCGEQRF
#define pcpotrf_	PCPOTRF
#define pcgeqr2_	PCGEQR2
#define pclarfb_	PCLARFB
#define pclarft_	PCLARFT
#define pcsytrf_	PCSYTRF
#define pcsytrs_	PCSYTRS
#define pcgetrs_	PCGETRS

#define pzgetrf_	PZGETRF
#define pzgeqrf_	PZGEQRF
#define pzpotrf_	PZPOTRF
#define pzgeqr2_	PZGEQR2
#define pzlarft_	PZLARFT
#define pzlarfb_	PZLARFB
#define pzsytrf_	PZSYTRF
#define pzsytrs_	PZSYTRS
#define pzgetrs_	PZGETRS
#endif /* UpCase */

#else				/* prefix names with a 'd' to aivod name clash*/

#if (FDATATYPE==SINGLE)         /*define procedure identifiers and names*/
# define P_GETRF        dpsgetrf_
# define P_GEQRF        dpsgeqrf_
# define P_GEQR2        dpsgeqr2_
# define P_POTRF        dpspotrf_ 
# define P_LARFT	dpslarft_
# define P_LARFB	dpslarfb_
#elif (FDATATYPE==DOUBLE)
# define P_GETRF        dpdgetrf_
# define P_GEQRF        dpdgeqrf_
# define P_GEQR2        dpdgeqr2_
# define P_POTRF        dpdpotrf_ 
# define P_LARFT	dpdlarft_
# define P_LARFB	dpdlarfb_
#endif /*FDATATYPE*/

#ifdef NoChange
#define dpsgetrf_	dpsgetrf
#define dpsgeqrf_	dpsgeqrf
#define dpsgeqr2_	dpsgeqrf
#define dpslarfb_	dpslarfb
#define dpslarft_	dpslarft
#define dpspotrf_	dpspotrf

#define dpdgetrf_	dpdgetrf
#define dpdgeqrf_	dpdgeqrf
#define dpdgeqr2_	dpdgeqrf
#define dpdlarfb_	dpdlarfb
#define dpdlarft_	dpdlarft
#define dpspotrf_	dpdpotrf
#endif /* NoChange */

#ifdef UpCase
#define dpsgetrf_	DPSGETRF
#define dpsgeqrf_	DPSGEQRF
#define dpsgeqr2_	DPSGEQRF
#define dpslarfb_	DPSLARFB
#define dpslarft_	DPSLARFT
#define dpspotrf_	DPSPOTRF

#define dpdgetrf_	DPDGETRF
#define dpdgeqrf_	DPDGEQRF
#define dpdgeqr2_	DPDGEQRF
#define dpdlarfb_	DPDLARFB
#define dpdlarft_	DPDLARFT
#define dpspotrf_	DPSPOTRF
#endif /* UpCase */

#endif /*ALTNAMES */

#include "GenMacros.h"
#include "FDATASetUp.h"
#include "F2C.h"

/********* standard ScaLAPACK routines - see ScaLAPACK for pre/post **********/


F_VOID_FCT P_GETRF STDC_PARAMS(
	(int *M, int *N, FDATA A[], int *IA, int *JA, int *DESCA, 
	 int IPIV[], int *INFO)
);

F_VOID_FCT P_POTRF STDC_PARAMS(
	(F_CHAR_T UPLO, int *N, FDATA A[], int *IA, int *JA, int *DESCA, 
	 int *INFO)
);

F_VOID_FCT P_GEQRF STDC_PARAMS(
	(int *M, int *N, FDATA A[], int *IA, int *JA, int *DESCA, 
	 FDATA TAU[], FDATA WORK[], int LWORK[], int *INFO)
);

F_VOID_FCT P_GEQR2 STDC_PARAMS(
	(int *M, int *N, FDATA A[], int *IA, int *JA, int *DESCA, 
	 FDATA TAU[], FDATA WORK[], int LWORK[], int *INFO)
);

F_VOID_FCT P_LARFB STDC_PARAMS(
	(F_CHAR_T SIDE, F_CHAR_T TRANS, F_CHAR_T DIRECT, F_CHAR_T STOREV,
	int *M, int *N, int *K, FDATA V[], int *IV, int *JV, int *DESCV, 
	FDATA T[], FDATA C[], int *IC, int *JC, int *DESCC, FDATA WORK[])
);

F_VOID_FCT P_LARFT STDC_PARAMS(
	(F_CHAR_T DIRECT, F_CHAR_T STOREV,
	int *N, int *K, FDATA V[], int *IV, int *JV, int *DESCV, 
	FDATA TAU[], FDATA T[], FDATA WORK[])
);

/********* new routines with ScaLAPACK-like interfaces ***************/


F_VOID_FCT P_SYTRF STDC_PARAMS(
	(F_CHAR_T FUpLo, int *n, FDATA A[], int *ia, int *ja, int desca[], 
	 FDATA diaginv[], int ipiv[], int *info )
);
/* pre:  ipiv[] is a vector replicated over all cells,
 *       and has storage for at least *n elements.
 *       diaginv is a column-replicated vector, and has storage for 3*n_loc
 *       elements, where n_loc is the local column length of A.
 *       (A,*ia,*ja,desca) represents a global symmetric N x N matrix.
 *	 *FUpLo = 'L'.
 * post: the lower half of A is overwritten by L\D,
 *       where L is a lower triangular matrix stored in the proper lower
 *       triangular portion of A (with implicit unit diagonal)
 *       and D is a diagonal matrix of 1x1 or 2x2 sub-blocks
 *       (the latter occurs only where P[i] < 0) where
 *              P' A_pre P'^T = L*D*L^T
 *       where P' is matrix made from permutations P'[1], ... P[*n]
 *       and P'[i] signifies to interchange rows and columns i and |ipiv[i]|
 *	 (for i=1,..,*n)
 *       diaginv contains elements of D^-1 for all diagonal elements
 *       in this processor row. This enables optimizations in D_SYTRS().
 *	 If *info==0, the inverse of A exists, otherwise *info = the column
 *	 index of the first zero column of D.  
 * note: 1. the values of ipiv[] follow a Fortran indexing convention,
 *	 eg. *ipiv=4 means interchange columns of Fortran indices 1 and 4,
 *	 which corresponds to C indices of columns 0 and 3.
 *	 2. unlike in LAPACK _zytrf(), row interchanges on A are always
 *	 completed. This means that on a 1x1 grid, _sytrs() can *not*
 *	 use a matrix factored by P_SYTRF() *unless* the row
 *	 swaps of ipiv[] are first `undone'.
 */

F_VOID_FCT P_SYTRS STDC_PARAMS(
	(F_CHAR_T FUpLo, int *n, int *nrhs, FDATA A[], int *ia, int *ja, int desc_A[], 
	 FDATA diaginv[], int ipiv[], FDATA B[], int *ib, int *jb, int descb[], 
	 int *info )
);              

/* pre:  ipiv[] is a vector replicated over all cells,
 *       and has storage for at least *n elements.
 *       diaginv is a column-replicated vector, and has storage for 3*n_loc
 *       elements, where n_loc is the local column length of A.                 
 *       (A,*ia,*ja,desca) represents a global *n x *n matrix,
 *	 and (B,*ib,*jb,descb) represents an *n x *nrhs matrix.
 *       *FUpLo = 'L' and desca[MB_] = desca[NB_] = descb[MB_].
 *       The lower half of A  contains L\D,
 *       where L is stored in the proper lower
 *       triangular portion of A (with implicit unit diagonal)
 *       and D is a diagonal matrix of 1x1 or 2x2 sub-blocks
 *       (the latter occurs where P[i] < 0).
 *       diaginv contains elements of D^-1 for all diagonal elements
 *       in this processor row. It must have been initialised by P_SYTRF().
 * post: B <- P L^_T D^-1 L^-1 P^T B
 *       where P is matrix made from permutations P'[1], ... P'[*n]
 *       and P[i] signifies to interchange rows and columns i and |ipiv[i]|
 *	 (for i=1,..,*n).
 * notes: info is not used.
 */


F_VOID_FCT P_GETRS STDC_PARAMS(
	(F_CHAR_T FTrans, int *n, int *nrhs, FDATA A[], int *ia, int *ja, 
	 int desc_A[], int ipiv[], FDATA B[], int *ib, int *jb, int descb[], 
	 int *info )
);              

/* pre:  ipiv[] is a vector replicated over cell columns,
 *       and has storage for at least n_loc elements.
 *	 where n_loc is the local column length of A.                 
 *       (A,*ia,*ja,desca) represents a global *n x *n matrix,
 *	 and (B,*ib,*jb,descb) represents an *n x *nrhs matrix.
 *       desca[MB_] = desca[NB_] = descb[MB_].
 *       A contains L\U, where L is stored in the proper lower
 *       triangular portion of A (with implicit unit diagonal)
 *       and U is an upper triangular matrix.
 * post: B <- U^-1 L^-1 P' B, 	if *FTrans==NoTranspose
 *            P'^T L^-T U^-T B, otherwise
 *       where P is matrix made from permutations P'[1], ... P'[*n]
 *       and P'[i] signifies to interchange columns i and ipiv[i]
 *	 (for i=1,..,*n).
 * notes: info is not used.
 */



#if 0 /* usage notes for P_SYTRF(), P_SYTRS() */

compilation: requires DBLAS distributed BLAS library to be installed,
with the pathname ${DBLAS} being set to it root directory.
Required switches are:
 	-I${DBLAS}/DBLAS 		(indirectly included: GenMacros.h, F2C.h)
	-I${DBLAS}/PBLAS		
and also include paths for the BLACS (and MPI) libraries.

synopsis of calls:

#define FDATATYPE DOUBLE_COMPLEX 	/* alt.: SINGLE, DOUBLE, COMPLEX */
#include "FDATASetUp.h"			/* defines FDATA */
#include "FDCommun.h"   		/* MPICommSet(), GridInit() */
#include "ScaLAPACKMisc.h"   		/* defines P_SYTRF(), P_SYTRS() */
#include "PBLAS.h"   			/* defines PBLAS descriptor macros */

#include "blacs.h"   
#include "mpi.h"   
#include <assert.h>   
  ...
  int n, nrhs, ia=1, ja=1, ib=1, jb=1, desca[DLEN_], descb[DLEN_], *ipiv, info;
  FDATA *A, *B, *diaginv;		/* FDATA = struct {double r, i; };
				 	   for FDATATYPE==DOUBLE_COMPLEX */...
  MPI_Comm MPIComm;			int I, I0, I1, P, P0, P1;
  ... 
  /* set up n, nrhs, A, B, desca[], descb[] as desired.
     note restriction for P_SYTRS(): desca[MB_] = desca[NB_] = descb[MB_] */
  ...
  blacs_gridinfo_(&desca[CTXT_], &P0, &P1, &I0, &I1); 
  ipiv = (int *) malloc(n*sizeof(int));
  diaginv = (FDATA *) malloc(3 * ((n + desca[MB_] + P0-1) / P0) * sizeof(FDATA));
  
  /* The following is needed only for the MPI version of P_SYTRF().
     First, set MPIComm to an MPI communicator so that its cells, if arranged
     in a row-major order, correspond exactly to those of desca[CTXT_] */
  MPI_Comm_rank(MPIComm, &I);		MPI_Comm_size(MPIComm, &P);
  assert( (P == P0*P1) && (I == I0*P1 + I1) );	/* checks setup of MPIComm */
  MPICommSet((int) MPIComm);		/* sets up the DBLAS to use MPI to ...*/
  GridInit(P0, P1);			/* ... simulate the logical P0xP1 grid*/

  P_SYTRF("Lower", &n, A, &ia, &ib, desca, diaginv, ipiv, &info);
					/* factors the matrix A */
  ...					
  if (info==0) {			/* A was invertible, can solve */ 
    P_SYTRS("Lower", &n, &nrhs, A, &ia, &ib, desca, diaginv, ipiv,
            B, &ib, &jb, descb, &info);
  }   
  ...
  free((char *) ipiv);			free((char *) diaginv);
  ...
    
linking: P_SYTRF()/P_SYTRS() require the extra libraries (in the case of
DOUBLE_COMPLEX (ie.  'z') on an ap3000): 
	${DBLAS}/LIB/scalapack_z_ap3000.a  ${DBLAS}/LIB/dlapack_z_ap3000.a
	${DBLAS}/LIB/dblas_z_ap3000.a
The above should have been compiled with the -DMPI switch for the
MPI version of P_SYTRS(); otherwise by the -DBLACS switch.		   
Also, the improved BLAS should be linked in:
	${DBLAS}/LIB/ZDBlas.a  
#endif /* usage notes comment */

/******************************* misc definitions *************************/

void getoptw_( int *w );

extern int TauRowRep;

#endif /* __ScaLAPACKMisc_INCL__ */
